/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: jtag_uart.c 1 2010-06-14 02:33:52Z ertl-ichiba $
 */

/*
 *  ꥢI/OǥХSIO˥ɥ饤СJTAG UARTѡ
 */

#include <kernel.h>
#include <t_syslog.h>
#include "target_syssvc.h"
#include "target_serial.h"

/*
 *  ꥢI/OݡȽ֥å
 */
typedef struct sio_port_initialization_block 
{
	void*    ctrl;
	void*    data;
	uint32_t intno;
}
SIOPINIB;

/*
 *  ꥢI/Oݡȴ֥å
 */
struct sio_port_control_block 
{
	const SIOPINIB  *p_siopinib;  /* ꥢI/OݡȽ֥å */
	intptr_t        exinf;        /* ĥ */
	bool_t    openflag;             /* ץѤߥե饰 */
	bool_t    sendflag;             /* ߥ֥͡ե饰 */
	bool_t    getready;             /* ʸ */
	bool_t    putready;             /* ʸǤ */
};

/*
 * ꥢI/OݡȽ֥å
 */
const SIOPINIB siopinib_table[TNUM_PORT] = {
	{
		(void*)(JTAG_UART_PORT1_BASE + JTAG_UART_CONTROL_OFFSET),
		(void*)(JTAG_UART_PORT1_BASE + JTAG_UART_DATA_OFFSET),
		(uint32_t)INTNO_SIO_PORT1
	},
#if TNUM_PORT >= 2
	{
		(void*)(JTAG_UART_PORT2_BASE + JTAG_UART_CONTROL_OFFSET),
		(void*)(JTAG_UART_PORT2_BASE + JTAG_UART_DATA_OFFSET),
		(uint32_t)INTNO_SIO_PORT2
	},
#endif /* TNUM_PORT >= 2 */
#if TNUM_PORT >= 3
	{
		(void*)(JTAG_UART_PORT3_BASE + JTAG_UART_CONTROL_OFFSET),
		(void*)(JTAG_UART_PORT3_BASE + JTAG_UART_DATA_OFFSET),
		(uint32_t)INTNO_SIO_PORT3
	},
#endif /* TNUM_PORT >= 3 */
};

/*
 *  ꥢI/Oݡȴ֥åΥꥢ
 */
SIOPCB	siopcb_table[TNUM_PORT];

/*
 *  ꥢI/OݡID֥åФΥޥ
 */
#define INDEX_SIOP(siopid)  ((uint_t)((siopid) - 1))
#define get_siopcb(siopid)  (&(siopcb_table[INDEX_SIOP(siopid)]))

/*
 *  JTAG_UART ϥơȥǡƱ˼뤿ᡤơ
 *  åȥǡɤ߹ǤޤΤᡤuart_getready()
 *  ¹ԤΥǡ롥
 */ 
static int8_t jtag_uart_buf = -1;

/*
 * ʸ?
 */ 
Inline bool_t
uart_getready(SIOPCB *p_siopcb)
{
	uint32_t tmp = sil_rew_iop(p_siopcb->p_siopinib->data);
	jtag_uart_buf = (uint8_t)tmp;
	return ((tmp & JTAG_UART_DATA_RVALID) != 0);
}

/*
 * ʸǤ뤫?
 */
Inline bool_t
uart_putready(SIOPCB *p_siopcb)
{
		return((sil_rew_iop(p_siopcb->p_siopinib->ctrl)
				& JTAG_UART_CONTROL_WSAPCE) > 0);
}

/*
 *  ʸμФ
 */
Inline uint8_t
uart_getchar(SIOPCB *p_siopcb)
{
	return((uint8_t)(sil_rew_iop(p_siopcb->p_siopinib->data)));
}

/*
 *  ʸν񤭹
 */
Inline void
uart_putchar(SIOPCB *p_siopcb, uint8_t c)
{
	sil_wrw_iop(p_siopcb->p_siopinib->data, c);
}

/*
 * ؿ
 */
/*
 *  ߵ
 */
Inline void
uart_enable_send(SIOPCB *p_siopcb)
{
	sil_wrw_iop(p_siopcb->p_siopinib->ctrl,
				sil_rew_iop(p_siopcb->p_siopinib->ctrl)
				|JTAG_UART_CONTROL_WIE);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_send(SIOPCB *p_siopcb)
{
	sil_wrw_iop(p_siopcb->p_siopinib->ctrl,
				sil_rew_iop(p_siopcb->p_siopinib->ctrl)
				& ~JTAG_UART_CONTROL_WIE);
}


/*
 *  ߵ
 */
Inline void
uart_enable_rcv(SIOPCB *p_siopcb)
{
	sil_wrw_iop(p_siopcb->p_siopinib->ctrl,
				sil_rew_iop(p_siopcb->p_siopinib->ctrl)
				| JTAG_UART_CONTROL_RIE);
}

/*
 *  ߶ػ
 */
Inline void
uart_disable_rcv(SIOPCB *p_siopcb)
{
	sil_wrw_iop(p_siopcb->p_siopinib->ctrl,
				sil_rew_iop(p_siopcb->p_siopinib->ctrl)
				& ~JTAG_UART_CONTROL_RIE);
}


/*
 *  SIOɥ饤Фν
 */
void
sio_initialize(intptr_t exinf)
{
	SIOPCB  *p_siopcb;
	uint_t  i;

	/*
	 *  ꥢI/Oݡȴ֥åν
	 */
	for (p_siopcb = siopcb_table, i = 0; i < TNUM_PORT; p_siopcb++, i++) {
		p_siopcb->p_siopinib = &(siopinib_table[i]);
		p_siopcb->openflag = false;
		p_siopcb->sendflag = false;
	}
}

/*
 * ꥢI/OݡȤΥץ
 */
SIOPCB *
jtag_uartl_opn_por(SIOPCB *p_siopcb, intptr_t exinf)
{
	const SIOPINIB  *p_siopinib;
	p_siopinib = p_siopcb->p_siopinib;

	p_siopcb->exinf = exinf;
	p_siopcb->getready = p_siopcb->putready = false;
	p_siopcb->openflag = true;

	return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥץ
 */
SIOPCB *
sio_opn_por(ID siopid, intptr_t exinf)
{
	SIOPCB  *p_siopcb = get_siopcb(siopid);
	bool_t    opnflg;
	ER      ercd;

	/*
	 *  ץ󤷤ݡȤ뤫opnflgɤǤ
	 */
	opnflg = p_siopcb->openflag;

	/*
	 *  ǥХ¸Υץ
	 */
	jtag_uartl_opn_por(p_siopcb, exinf);

	/*
	 *  ꥢI/OߤΥޥ롥
	 */
	if (!opnflg) {
		ercd = ena_int(p_siopcb->p_siopinib->intno);
		assert(ercd == E_OK);
	}
	return(p_siopcb);
}

/*
 *  ꥢI/OݡȤΥ
 */
void
sio_cls_por(SIOPCB *p_siopcb)
{
	const SIOPINIB  *p_siopinib;

	p_siopinib = p_siopcb->p_siopinib;
	
	/* ߤζػ */
	sil_wrw_iop(p_siopcb->p_siopinib->ctrl, 0x00);

	p_siopcb->openflag = false;

	/*
	 *  ꥢI/Oߤޥ롥
	 */
	dis_int(p_siopcb->p_siopinib->intno);
}

/*
 *  SIOγߥϥɥ
 */
void
sio_isr(intptr_t siopid)
{
	SIOPCB *p_siopcb = get_siopcb((ID)siopid);

	if (uart_getready(p_siopcb)) {
		/*
		 *  ΥХå롼ƤӽФ
		 */
		sio_irdy_rcv(p_siopcb->exinf);
	}
	if (uart_putready(p_siopcb)) {
		/*
		 *  ǽХå롼ƤӽФ
		 */
		sio_irdy_snd(p_siopcb->exinf);
	}
}

/*
 *  ꥢI/OݡȤؤʸ
 */
bool_t
sio_snd_chr(SIOPCB *siopcb, char_t c)
{
	if (uart_putready(siopcb)) {
		uart_putchar(siopcb, c);
		return(true);
	}
	return(false);
}

/*
 *  ꥢI/OݡȤʸ
 */
int_t
sio_rcv_chr(SIOPCB *siopcb)
{
	uint8_t tmp;

	if (jtag_uart_buf != -1) {
		tmp = jtag_uart_buf;
		jtag_uart_buf = -1;
		return tmp;
	}
	return(false);
}

/*
 *  ꥢI/OݡȤΥХåε
 */
void
sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_enable_send(siopcb);
		break;
	  case SIO_RDY_RCV:
		uart_enable_rcv(siopcb);
		break;
	}
}

/*
 *  ꥢI/OݡȤΥХåζػ
 */
void
sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn)
{
	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_disable_send(siopcb);
		break;
	  case SIO_RDY_RCV:
		uart_disable_rcv(siopcb);
		break;
	}
}
